## libaio 0.3.113

=== harness/Makefile ===
# foo.
TEST_SRCS:=$(shell find cases/ -name \*.t | sort -n -t/ -k2)
EXTRAPROGS:=cases/8.p cases/10.p
PARTPROGS:=$(filter-out $(EXTRAPROGS), $(patsubst %.t,%.p,$(TEST_SRCS)))
PROGS:=$(PARTPROGS) $(EXTRAPROGS)
HARNESS_SRCS:=main.c
# io_queue.c

CFLAGS+=-Wall -Werror -I../src -g -O2
#-lpthread -lrt

# gcc-11 does not like the test case in 3.t that
# passes an invalid pointer (-1) to the kernel, so
# tell the compiler we do not need a warning here
cases/3.p:	CFLAGS+=-Wno-stringop-overflow

# Change this on the build line to run tests against the installed libraries:
# make LIBAIO=-laio partcheck
LIBAIO?=../src/libaio.a

all: $(PROGS)

$(PROGS): %.p: %.t $(HARNESS_SRCS)
	$(CC) $(CFLAGS) -DTEST_NAME=\"$<\" -o $@ main.c $(LIBAIO) -lpthread

clean:
	rm -f $(PROGS) *.o runtests.out rofile wofile rwfile

.PHONY:

testdir/rofile: testdir .PHONY
	rm -f $@
	echo "test" >$@
	chmod 400 $@

testdir/wofile: testdir .PHONY
	rm -f $@
	echo "test" >$@
	chmod 200 $@

testdir/rwfile: testdir .PHONY
	rm -f $@
	echo "test" >$@
	chmod 600 $@

testdir testdir.enospc testdir.ext2:
	mkdir $@

root: .PHONY
	@if [ `id -u` -ne 0 ]; then echo Need root for check, try partcheck >&2; exit 1; fi

partcheck: $(PARTPROGS) testdir/rofile testdir/rwfile testdir/wofile
	./runtests.sh $(PARTPROGS)

ext2.img:
	dd if=/dev/zero bs=1M count=10 of=$@
	mke2fs -F -b 4096 $@

extracheck: $(EXTRAPROGS) root testdir.ext2 testdir.enospc ext2.img
	mount -o loop -t ext2 ext2-enospc.img testdir.enospc
	./runtests.sh cases/10.p; ret=$$?; umount testdir.enospc; exit $$ret
	mount -o loop -t ext2 ext2.img testdir.ext2
	./runtests.sh cases/8.p; ret=$$?; umount testdir.ext2; exit $$ret

check: partcheck extracheck

=== debian/changelog ===
libaio (0.3.113-6build1) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 07:43:21 +0000

libaio (0.3.113-6) unstable; urgency=medium

  * Switch from future=+lfs to abi=+lfs build flags feature, and Build-Depends
    on dpkg-dev >= 1.22.0.
  * Add time64 support:
    - Remove dead code for syscall handling.
    - Refactor code to use an internal implementation for public functions
      that handle timespec, by switching them to always use __kernel_timespec,
      and add conversion functions to map from 'struct timespec' to
      'struct __kernel_timespec', and from 'struct __kernel_timespec' to
      'struct __kernel_old_timespec'.
    - Add support for io_pgetevents_time64() Linux syscall, but disable it
      for now as it only works on 32-bit kernels, but not on the compat
      mode in 64-bit kernels running 32-bit userland, will be fixed in Linux
      in parallel, as the timeouts used are supposed to be relative anyway,
      and this does not and will not break ABI.
    - Add dual time32/time64 ABI support by adding io_getevents_time64() and
      io_pgetevents_time64() library functions on 32-bit architectures, that
      get redirected from the io_getevents() and io_pgetevents() functions
      when the user sets _TIME_BITS=64.
    - Perform a SONAME bump to avoid stomping on upstream SONAME. Once and if
      the new symbols are accepted by upstream then we can merge that back
      into libaio.so.1 and drop the t64 packages and temporarily provide
      a compat symlink for the t64 SONAME for a smooth transition back. This
      should also be an easier way to revert this transition when there are
      no file conflicts involved, and does not block on upstream support.
    - Do not rename the udeb from libaio1-udeb, as d-i does not care, and
      that would require a pointless trip through NEW. But update the shlibs
      references for the libaio1t64 rename.
    - We do not need a dependency on a newer dpkg-dev nor gcc as we are
      explicitly handling the time64 dual-ABI independently of the toolchain.
    Closes: #1062218

 -- Guillem Jover <guillem@debian.org>  Tue, 05 Mar 2024 11:33:54 +0100

libaio (0.3.113-5) unstable; urgency=medium

  * Wrap fields in debian/tests/control.
  * Fix upstream build system to remove all test artifacts on clean.
    Reported by Lucas Nussbaum <lucas@debian.org>.

 -- Guillem Jover <guillem@debian.org>  Sun, 06 Aug 2023 21:12:34 +0200

libaio (0.3.113-4) unstable; urgency=medium

  * Switch to Standards-Version 4.6.2 (no changes needed).
  * Do not trim debian/changelog.
  * Update debian/patches metadata.

 -- Guillem Jover <guillem@debian.org>  Wed, 18 Jan 2023 01:35:12 +0100

libaio (0.3.113-3) unstable; urgency=medium

  * Add upstream/metadata fields for bug submitting and database.
  * Update lintian overrides.
  * Switch to Standards-Version 4.6.1 (no changes needed).
  * Move debian/copyright Source field immediately after Format field.
  * Export DEB_BUILD_MAINT_OPTIONS and DEB_CFLAGS_MAINT_PREPEND.
  * Switch from hardening=+bindnow to hardening=+all.
  * Enable future=+lfs build feature as it does not affect the shared library
    ABI, but affects the test harness.

 -- Guillem Jover <guillem@debian.org>  Sun, 04 Dec 2022 18:06:09 +0100

libaio (0.3.113-2) unstable; urgency=medium

  * Skip new test case 23, which was added upstream for a kernel regression,
    so we are not worse off than before. Its failure was known and being
    looked at upstream.

 -- Guillem Jover <guillem@debian.org>  Tue, 19 Apr 2022 15:57:07 +0200

libaio (0.3.113-1) unstable; urgency=medium

  * New upstream release.
    - Remove patches taken from upstream, now unneeded.
    - Remove -Werror removal patch, as we override CFLAGS.
    - Refresh patches.
    - Update copyright years.
  * Add support for the noudeb build profile.

 -- Guillem Jover <guillem@debian.org>  Tue, 19 Apr 2022 03:22:49 +0200

=== debian/control ===
Source: libaio
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Guillem Jover <guillem@debian.org>
Priority: optional
Section: libs
Vcs-Browser: https://git.hadrons.org/cgit/debian/pkgs/libaio.git
Vcs-Git: https://git.hadrons.org/git/debian/pkgs/libaio.git
Homepage: https://pagure.io/libaio
Standards-Version: 4.6.2
Rules-Requires-Root: no
Build-Depends:
 debhelper-compat (= 13),
 debhelper (>= 13.10),
 dpkg-dev (>= 1.22.0),

Package: libaio1t64
Architecture: linux-any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Linux kernel AIO access library - shared library
 This library enables userspace to use Linux kernel asynchronous I/O
 system calls, important for the performance of databases and other
 advanced applications.
 .
 This package contains the shared library.

Package: libaio1-udeb
Package-Type: udeb
Section: debian-installer
Architecture: linux-any
Build-Profiles: <!noudeb>
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Linux kernel AIO access library - shared library
 This library enables userspace to use Linux kernel asynchronous I/O
 system calls, important for the performance of databases and other
 advanced applications.
 .
 This package contains the udeb shared library.

Package: libaio-dev
Section: libdevel
Architecture: linux-any
Multi-Arch: same
Depends:
 ${misc:Depends},
 libaio1t64 (= ${binary:Version}),
Description: Linux kernel AIO access library - development files
 This library enables userspace to use Linux kernel asynchronous I/O
 system calls, important for the performance of databases and other
 advanced applications.
 .
 This package contains the static library and the header files.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all abi=+lfs
export DEB_CFLAGS_MAINT_PREPEND = -Wall

include /usr/share/dpkg/default.mk
include /usr/share/dpkg/buildtools.mk

# The following architectures still fail the test suite:
#   m68k
#     (emulated, no proper test results)
#   sh4
#     (emulated, no proper test results)
#   x32
#     (20: io_setup failed)
#   riscv64
#     (5: 512 instead of EFAULT on write)
#   sparc64
#     (5: 512 instead of EFAULT on write)
#     (19: mremap EINVAL)
#   hppa
#     (5: 512 instead of EFAULT on write)
#     (19: mremap EINVAL)
#     (17: looping, timeout?)
ifneq (,$(filter $(DEB_HOST_ARCH),m68k sh4 x32 riscv64 sparc64 hppa))
  TESTS_FLAKY = yes
endif

export CC

%:
	dh $@

override_dh_auto_test:
ifeq ($(TESTS_FLAKY),yes)
	@echo "Notice: Running tests in flaky mode, errors will be ignored."
endif
	$(if $(TESTS_FLAKY),-)$(MAKE) partcheck \
	  CPPFLAGS="$(CPPFLAGS)" \
	  CFLAGS="$(CFLAGS)" \
	  LDFLAGS="$(LDFLAGS)"

override_dh_auto_install:
	dh_auto_install -- \
	  libdir=/usr/lib/$(DEB_HOST_MULTIARCH)

override_dh_installchangelogs:
	dh_installchangelogs --no-trim

override_dh_makeshlibs:
	# XXX: Ideally we'd also rename the udeb, but d-i does not really
	# care about file conflicts, and that would take us through NEW
	# in the middle of the time64 transition.
	dh_makeshlibs --add-udeb=libaio1-udeb

=== debian/tests/control ===
Tests:
 test-unit
Restrictions:
 flaky
 rw-build-tree
Depends:
 build-essential,
 libaio-dev,

Tests:
 test-unit-root
Restrictions:
 flaky
 rw-build-tree
 needs-root
Depends:
 build-essential,
 libaio-dev,

=== debian/watch ===
# Site		Directory		Pattern			Version	Script
version=4
https://releases.pagure.org/libaio/libaio-([\d\.]+)\.tar\.(?:gz|xz) debian uupdate

## libaio 0.3.113-6build1.1trisquel1

=== Makefile ===
NAME=libaio
SPECFILE=$(NAME).spec
VERSION=$(shell awk '/Version:/ { print $$2 }' $(SPECFILE))
TAG = $(NAME)-$(VERSION)
RPMBUILD=$(shell `which rpmbuild >&/dev/null` && echo "rpmbuild" || echo "rpm")

default: all

all:
	@$(MAKE) -C src

install:
	@$(MAKE) -C src install

check:
	@$(MAKE) -C harness check

partcheck: all
	@$(MAKE) -C harness partcheck

clean:
	@$(MAKE) -C src clean
	@$(MAKE) -C harness clean

tag-archive:
	@git tag $(TAG)

create-archive:
	@git archive --prefix=$(NAME)-$(VERSION)/ -o $(NAME)-$(VERSION).tar.gz $(TAG)
	@echo "The final archive is ./$(NAME)-$(VERSION).tar.gz."

archive: clean tag-archive create-archive

srpm: create-archive
	$(RPMBUILD) --define "_sourcedir `pwd`" --define "_srcrpmdir `pwd`" --nodeps -bs $(SPECFILE)

=== harness/Makefile ===
--- 
+++ 
@@ -1,18 +1,21 @@
 # foo.
 TEST_SRCS:=$(shell find cases/ -name \*.t | sort -n -t/ -k2)
-EXTRAPROGS:=cases/8.p cases/10.p
+EXTRAPROGS:=cases/8.p cases/10.p cases/23.p
 PARTPROGS:=$(filter-out $(EXTRAPROGS), $(patsubst %.t,%.p,$(TEST_SRCS)))
 PROGS:=$(PARTPROGS) $(EXTRAPROGS)
 HARNESS_SRCS:=main.c
 # io_queue.c
 
-CFLAGS+=-Wall -Werror -I../src -g -O2
+MK_CPPFLAGS = -I../src -D_FILE_OFFSET_BITS=64 -D_TIME_BITS=64 $(CPPFLAGS)
+CFLAGS ?= -Wall -Werror -g -O2
+MK_CFLAGS = $(CFLAGS)
 #-lpthread -lrt
+MK_LDFLAGS = main.c $(LIBAIO) -lpthread $(LDFLAGS)
 
 # gcc-11 does not like the test case in 3.t that
 # passes an invalid pointer (-1) to the kernel, so
 # tell the compiler we do not need a warning here
-cases/3.p:	CFLAGS+=-Wno-stringop-overflow
+cases/3.p:	MK_CFLAGS+=-Wno-stringop-overflow
 
 # Change this on the build line to run tests against the installed libraries:
 # make LIBAIO=-laio partcheck
@@ -21,10 +24,12 @@
 all: $(PROGS)
 
 $(PROGS): %.p: %.t $(HARNESS_SRCS)
-	$(CC) $(CFLAGS) -DTEST_NAME=\"$<\" -o $@ main.c $(LIBAIO) -lpthread
+	$(CC) $(MK_CPPFLAGS) $(MK_CFLAGS) -DTEST_NAME=\"$<\" -o $@ $(MK_LDFLAGS)
 
 clean:
-	rm -f $(PROGS) *.o runtests.out rofile wofile rwfile
+	rm -f $(PROGS) *.o runtests.out tempfile testfile
+	rm -f testdir/rofile testdir/wofile testdir/rwfile
+	rmdir testdir || true
 
 .PHONY:

=== src/Makefile ===
prefix ?= /usr
includedir ?= $(prefix)/include
libdir ?= $(prefix)/lib

MK_CPPFLAGS = -I. -D_FILE_OFFSET_BITS=64 -D_TIME_BITS=64 $(CPPFLAGS)
CFLAGS ?= -Wall -g -fomit-frame-pointer -O2
MK_CFLAGS = -fPIC $(CFLAGS)
SO_CFLAGS = -shared $(MK_CFLAGS)
L_CFLAGS = $(MK_CFLAGS)
MK_LDFLAGS = $(LDFLAGS)
ENABLE_SHARED ?= 1

soname=libaio.so.1t64
minor=0
micro=2
libname=$(soname).$(minor).$(micro)
all_targets += libaio.a

ifeq ($(ENABLE_SHARED),1)
all_targets += $(libname)
endif

all: $(all_targets)

# libaio provided functions
libaio_srcs := io_queue_init.c io_queue_release.c
libaio_srcs += io_queue_wait.c io_queue_run.c

# real syscalls
libaio_srcs += aio_pgetevents.c aio_getevents.c
libaio_srcs += io_getevents.c io_submit.c io_cancel.c
libaio_srcs += io_setup.c io_destroy.c io_pgetevents.c
libaio_srcs += io_pgetevents_time64.c io_getevents_time64.c

# old symbols
libaio_srcs += compat-0_1.c

libaio_objs := $(patsubst %.c,%.ol,$(libaio_srcs))
libaio_sobjs := $(patsubst %.c,%.os,$(libaio_srcs))

$(libaio_objs) $(libaio_sobjs): libaio.h

%.os: %.c
	$(CC) $(MK_CPPFLAGS) $(SO_CFLAGS) -c -o $@ $<

%.ol: %.c
	$(CC) $(MK_CPPFLAGS) $(L_CFLAGS) -c -o $@ $<

AR ?= ar
RANLIB ?= ranlib
libaio.a: $(libaio_objs)
	rm -f libaio.a
	$(AR) r libaio.a $^
	$(RANLIB) libaio.a

$(libname): $(libaio_sobjs) libaio.map
	$(CC) $(MK_CPPFLAGS) $(MK_CFLAGS) -c struct_offsets.c
	$(CC) $(SO_CFLAGS) -Wl,--version-script=libaio.map -Wl,-soname=$(soname) -o $@ $(libaio_sobjs) $(MK_LDFLAGS)

install: $(all_targets)
	install -D -m 644 libaio.h $(DESTDIR)$(includedir)/libaio.h
	install -D -m 644 libaio.a $(DESTDIR)$(libdir)/libaio.a
ifeq ($(ENABLE_SHARED),1)
	install -D -m 755 $(libname) $(DESTDIR)$(libdir)/$(libname)
	ln -sf $(libname) $(DESTDIR)$(libdir)/$(soname)
	ln -sf $(libname) $(DESTDIR)$(libdir)/libaio.so
endif

$(libaio_objs): libaio.h

clean:
	rm -f $(all_targets) $(libaio_objs) $(libaio_sobjs) $(soname).new
	rm -f *.so* *.a *.o

=== .pc/0005-build-Honor-user-build-flags.patch/src/Makefile ===
prefix ?= /usr
includedir ?= $(prefix)/include
libdir ?= $(prefix)/lib

CFLAGS ?= -g -fomit-frame-pointer -O2
CFLAGS += -Wall -I. -fPIC
SO_CFLAGS=-shared $(CFLAGS)
L_CFLAGS=$(CFLAGS)
LINK_FLAGS=
LINK_FLAGS+=$(LDFLAGS)
ENABLE_SHARED ?= 1

soname=libaio.so.1
minor=0
micro=2
libname=$(soname).$(minor).$(micro)
all_targets += libaio.a

ifeq ($(ENABLE_SHARED),1)
all_targets += $(libname)
endif

all: $(all_targets)

# libaio provided functions
libaio_srcs := io_queue_init.c io_queue_release.c
libaio_srcs += io_queue_wait.c io_queue_run.c

# real syscalls
libaio_srcs += io_getevents.c io_submit.c io_cancel.c
libaio_srcs += io_setup.c io_destroy.c io_pgetevents.c

# internal functions
libaio_srcs += raw_syscall.c

# old symbols
libaio_srcs += compat-0_1.c

libaio_objs := $(patsubst %.c,%.ol,$(libaio_srcs))
libaio_sobjs := $(patsubst %.c,%.os,$(libaio_srcs))

$(libaio_objs) $(libaio_sobjs): libaio.h vsys_def.h

%.os: %.c
	$(CC) $(SO_CFLAGS) -c -o $@ $<

%.ol: %.c
	$(CC) $(L_CFLAGS) -c -o $@ $<

AR ?= ar
RANLIB ?= ranlib
libaio.a: $(libaio_objs)
	rm -f libaio.a
	$(AR) r libaio.a $^
	$(RANLIB) libaio.a

$(libname): $(libaio_sobjs) libaio.map
	$(CC) $(CFLAGS) -c struct_offsets.c
	$(CC) $(SO_CFLAGS) -Wl,--version-script=libaio.map -Wl,-soname=$(soname) -o $@ $(libaio_sobjs) $(LINK_FLAGS)

install: $(all_targets)
	install -D -m 644 libaio.h $(DESTDIR)$(includedir)/libaio.h
	install -D -m 644 libaio.a $(DESTDIR)$(libdir)/libaio.a
ifeq ($(ENABLE_SHARED),1)
	install -D -m 755 $(libname) $(DESTDIR)$(libdir)/$(libname)
	ln -sf $(libname) $(DESTDIR)$(libdir)/$(soname)
	ln -sf $(libname) $(DESTDIR)$(libdir)/libaio.so
endif

$(libaio_objs): libaio.h

clean:
	rm -f $(all_targets) $(libaio_objs) $(libaio_sobjs) $(soname).new
	rm -f *.so* *.a *.o

=== .pc/0006-build-Remove-all-test-artifacts-on-clean.patch/harness/Makefile ===
# foo.
TEST_SRCS:=$(shell find cases/ -name \*.t | sort -n -t/ -k2)
EXTRAPROGS:=cases/8.p cases/10.p
PARTPROGS:=$(filter-out $(EXTRAPROGS), $(patsubst %.t,%.p,$(TEST_SRCS)))
PROGS:=$(PARTPROGS) $(EXTRAPROGS)
HARNESS_SRCS:=main.c
# io_queue.c

MK_CPPFLAGS = -I../src $(CPPFLAGS)
CFLAGS ?= -Wall -Werror -g -O2
MK_CFLAGS = $(CFLAGS)
#-lpthread -lrt
MK_LDFLAGS = main.c $(LIBAIO) -lpthread $(LDFLAGS)

# gcc-11 does not like the test case in 3.t that
# passes an invalid pointer (-1) to the kernel, so
# tell the compiler we do not need a warning here
cases/3.p:	MK_CFLAGS+=-Wno-stringop-overflow

# Change this on the build line to run tests against the installed libraries:
# make LIBAIO=-laio partcheck
LIBAIO?=../src/libaio.a

all: $(PROGS)

$(PROGS): %.p: %.t $(HARNESS_SRCS)
	$(CC) $(MK_CPPFLAGS) $(MK_CFLAGS) -DTEST_NAME=\"$<\" -o $@ $(MK_LDFLAGS)

clean:
	rm -f $(PROGS) *.o runtests.out rofile wofile rwfile

.PHONY:

testdir/rofile: testdir .PHONY
	rm -f $@
	echo "test" >$@
	chmod 400 $@

testdir/wofile: testdir .PHONY
	rm -f $@
	echo "test" >$@
	chmod 200 $@

testdir/rwfile: testdir .PHONY
	rm -f $@
	echo "test" >$@
	chmod 600 $@

testdir testdir.enospc testdir.ext2:
	mkdir $@

root: .PHONY
	@if [ `id -u` -ne 0 ]; then echo Need root for check, try partcheck >&2; exit 1; fi

partcheck: $(PARTPROGS) testdir/rofile testdir/rwfile testdir/wofile
	./runtests.sh $(PARTPROGS)

ext2.img:
	dd if=/dev/zero bs=1M count=10 of=$@
	mke2fs -F -b 4096 $@

extracheck: $(EXTRAPROGS) root testdir.ext2 testdir.enospc ext2.img
	mount -o loop -t ext2 ext2-enospc.img testdir.enospc
	./runtests.sh cases/10.p; ret=$$?; umount testdir.enospc; exit $$ret
	mount -o loop -t ext2 ext2.img testdir.ext2
	./runtests.sh cases/8.p; ret=$$?; umount testdir.ext2; exit $$ret

check: partcheck extracheck

=== .pc/0009-Remove-unused-vsys_def.h.patch/src/Makefile ===
prefix ?= /usr
includedir ?= $(prefix)/include
libdir ?= $(prefix)/lib

MK_CPPFLAGS = -I. $(CPPFLAGS)
CFLAGS ?= -Wall -g -fomit-frame-pointer -O2
MK_CFLAGS = -fPIC $(CFLAGS)
SO_CFLAGS = -shared $(MK_CFLAGS)
L_CFLAGS = $(MK_CFLAGS)
MK_LDFLAGS = $(LDFLAGS)
ENABLE_SHARED ?= 1

soname=libaio.so.1
minor=0
micro=2
libname=$(soname).$(minor).$(micro)
all_targets += libaio.a

ifeq ($(ENABLE_SHARED),1)
all_targets += $(libname)
endif

all: $(all_targets)

# libaio provided functions
libaio_srcs := io_queue_init.c io_queue_release.c
libaio_srcs += io_queue_wait.c io_queue_run.c

# real syscalls
libaio_srcs += io_getevents.c io_submit.c io_cancel.c
libaio_srcs += io_setup.c io_destroy.c io_pgetevents.c

# internal functions
libaio_srcs += raw_syscall.c

# old symbols
libaio_srcs += compat-0_1.c

libaio_objs := $(patsubst %.c,%.ol,$(libaio_srcs))
libaio_sobjs := $(patsubst %.c,%.os,$(libaio_srcs))

$(libaio_objs) $(libaio_sobjs): libaio.h vsys_def.h

%.os: %.c
	$(CC) $(MK_CPPFLAGS) $(SO_CFLAGS) -c -o $@ $<

%.ol: %.c
	$(CC) $(MK_CPPFLAGS) $(L_CFLAGS) -c -o $@ $<

AR ?= ar
RANLIB ?= ranlib
libaio.a: $(libaio_objs)
	rm -f libaio.a
	$(AR) r libaio.a $^
	$(RANLIB) libaio.a

$(libname): $(libaio_sobjs) libaio.map
	$(CC) $(MK_CPPFLAGS) $(MK_CFLAGS) -c struct_offsets.c
	$(CC) $(SO_CFLAGS) -Wl,--version-script=libaio.map -Wl,-soname=$(soname) -o $@ $(libaio_sobjs) $(MK_LDFLAGS)

install: $(all_targets)
	install -D -m 644 libaio.h $(DESTDIR)$(includedir)/libaio.h
	install -D -m 644 libaio.a $(DESTDIR)$(libdir)/libaio.a
ifeq ($(ENABLE_SHARED),1)
	install -D -m 755 $(libname) $(DESTDIR)$(libdir)/$(libname)
	ln -sf $(libname) $(DESTDIR)$(libdir)/$(soname)
	ln -sf $(libname) $(DESTDIR)$(libdir)/libaio.so
endif

$(libaio_objs): libaio.h

clean:
	rm -f $(all_targets) $(libaio_objs) $(libaio_sobjs) $(soname).new
	rm -f *.so* *.a *.o

=== .pc/0010-Remove-unused-raw_syscall.c.patch/src/Makefile ===
prefix ?= /usr
includedir ?= $(prefix)/include
libdir ?= $(prefix)/lib

MK_CPPFLAGS = -I. $(CPPFLAGS)
CFLAGS ?= -Wall -g -fomit-frame-pointer -O2
MK_CFLAGS = -fPIC $(CFLAGS)
SO_CFLAGS = -shared $(MK_CFLAGS)
L_CFLAGS = $(MK_CFLAGS)
MK_LDFLAGS = $(LDFLAGS)
ENABLE_SHARED ?= 1

soname=libaio.so.1
minor=0
micro=2
libname=$(soname).$(minor).$(micro)
all_targets += libaio.a

ifeq ($(ENABLE_SHARED),1)
all_targets += $(libname)
endif

all: $(all_targets)

# libaio provided functions
libaio_srcs := io_queue_init.c io_queue_release.c
libaio_srcs += io_queue_wait.c io_queue_run.c

# real syscalls
libaio_srcs += io_getevents.c io_submit.c io_cancel.c
libaio_srcs += io_setup.c io_destroy.c io_pgetevents.c

# internal functions
libaio_srcs += raw_syscall.c

# old symbols
libaio_srcs += compat-0_1.c

libaio_objs := $(patsubst %.c,%.ol,$(libaio_srcs))
libaio_sobjs := $(patsubst %.c,%.os,$(libaio_srcs))

$(libaio_objs) $(libaio_sobjs): libaio.h

%.os: %.c
	$(CC) $(MK_CPPFLAGS) $(SO_CFLAGS) -c -o $@ $<

%.ol: %.c
	$(CC) $(MK_CPPFLAGS) $(L_CFLAGS) -c -o $@ $<

AR ?= ar
RANLIB ?= ranlib
libaio.a: $(libaio_objs)
	rm -f libaio.a
	$(AR) r libaio.a $^
	$(RANLIB) libaio.a

$(libname): $(libaio_sobjs) libaio.map
	$(CC) $(MK_CPPFLAGS) $(MK_CFLAGS) -c struct_offsets.c
	$(CC) $(SO_CFLAGS) -Wl,--version-script=libaio.map -Wl,-soname=$(soname) -o $@ $(libaio_sobjs) $(MK_LDFLAGS)

install: $(all_targets)
	install -D -m 644 libaio.h $(DESTDIR)$(includedir)/libaio.h
	install -D -m 644 libaio.a $(DESTDIR)$(libdir)/libaio.a
ifeq ($(ENABLE_SHARED),1)
	install -D -m 755 $(libname) $(DESTDIR)$(libdir)/$(libname)
	ln -sf $(libname) $(DESTDIR)$(libdir)/$(soname)
	ln -sf $(libname) $(DESTDIR)$(libdir)/libaio.so
endif

$(libaio_objs): libaio.h

clean:
	rm -f $(all_targets) $(libaio_objs) $(libaio_sobjs) $(soname).new
	rm -f *.so* *.a *.o

=== .pc/0021-Add-time64-syscall-support.patch/src/Makefile ===
prefix ?= /usr
includedir ?= $(prefix)/include
libdir ?= $(prefix)/lib

MK_CPPFLAGS = -I. $(CPPFLAGS)
CFLAGS ?= -Wall -g -fomit-frame-pointer -O2
MK_CFLAGS = -fPIC $(CFLAGS)
SO_CFLAGS = -shared $(MK_CFLAGS)
L_CFLAGS = $(MK_CFLAGS)
MK_LDFLAGS = $(LDFLAGS)
ENABLE_SHARED ?= 1

soname=libaio.so.1
minor=0
micro=2
libname=$(soname).$(minor).$(micro)
all_targets += libaio.a

ifeq ($(ENABLE_SHARED),1)
all_targets += $(libname)
endif

all: $(all_targets)

# libaio provided functions
libaio_srcs := io_queue_init.c io_queue_release.c
libaio_srcs += io_queue_wait.c io_queue_run.c

# real syscalls
libaio_srcs += io_getevents.c io_submit.c io_cancel.c
libaio_srcs += io_setup.c io_destroy.c io_pgetevents.c

# old symbols
libaio_srcs += compat-0_1.c

libaio_objs := $(patsubst %.c,%.ol,$(libaio_srcs))
libaio_sobjs := $(patsubst %.c,%.os,$(libaio_srcs))

$(libaio_objs) $(libaio_sobjs): libaio.h

%.os: %.c
	$(CC) $(MK_CPPFLAGS) $(SO_CFLAGS) -c -o $@ $<

%.ol: %.c
	$(CC) $(MK_CPPFLAGS) $(L_CFLAGS) -c -o $@ $<

AR ?= ar
RANLIB ?= ranlib
libaio.a: $(libaio_objs)
	rm -f libaio.a
	$(AR) r libaio.a $^
	$(RANLIB) libaio.a

$(libname): $(libaio_sobjs) libaio.map
	$(CC) $(MK_CPPFLAGS) $(MK_CFLAGS) -c struct_offsets.c
	$(CC) $(SO_CFLAGS) -Wl,--version-script=libaio.map -Wl,-soname=$(soname) -o $@ $(libaio_sobjs) $(MK_LDFLAGS)

install: $(all_targets)
	install -D -m 644 libaio.h $(DESTDIR)$(includedir)/libaio.h
	install -D -m 644 libaio.a $(DESTDIR)$(libdir)/libaio.a
ifeq ($(ENABLE_SHARED),1)
	install -D -m 755 $(libname) $(DESTDIR)$(libdir)/$(libname)
	ln -sf $(libname) $(DESTDIR)$(libdir)/$(soname)
	ln -sf $(libname) $(DESTDIR)$(libdir)/libaio.so
endif

$(libaio_objs): libaio.h

clean:
	rm -f $(all_targets) $(libaio_objs) $(libaio_sobjs) $(soname).new
	rm -f *.so* *.a *.o

=== .pc/0022-Add-time64-public-functions-on-32-bit-architectures.patch/harness/Makefile ===
# foo.
TEST_SRCS:=$(shell find cases/ -name \*.t | sort -n -t/ -k2)
EXTRAPROGS:=cases/8.p cases/10.p
PARTPROGS:=$(filter-out $(EXTRAPROGS), $(patsubst %.t,%.p,$(TEST_SRCS)))
PROGS:=$(PARTPROGS) $(EXTRAPROGS)
HARNESS_SRCS:=main.c
# io_queue.c

MK_CPPFLAGS = -I../src $(CPPFLAGS)
CFLAGS ?= -Wall -Werror -g -O2
MK_CFLAGS = $(CFLAGS)
#-lpthread -lrt
MK_LDFLAGS = main.c $(LIBAIO) -lpthread $(LDFLAGS)

# gcc-11 does not like the test case in 3.t that
# passes an invalid pointer (-1) to the kernel, so
# tell the compiler we do not need a warning here
cases/3.p:	MK_CFLAGS+=-Wno-stringop-overflow

# Change this on the build line to run tests against the installed libraries:
# make LIBAIO=-laio partcheck
LIBAIO?=../src/libaio.a

all: $(PROGS)

$(PROGS): %.p: %.t $(HARNESS_SRCS)
	$(CC) $(MK_CPPFLAGS) $(MK_CFLAGS) -DTEST_NAME=\"$<\" -o $@ $(MK_LDFLAGS)

clean:
	rm -f $(PROGS) *.o runtests.out tempfile testfile
	rm -f testdir/rofile testdir/wofile testdir/rwfile
	rmdir testdir || true

.PHONY:

testdir/rofile: testdir .PHONY
	rm -f $@
	echo "test" >$@
	chmod 400 $@

testdir/wofile: testdir .PHONY
	rm -f $@
	echo "test" >$@
	chmod 200 $@

testdir/rwfile: testdir .PHONY
	rm -f $@
	echo "test" >$@
	chmod 600 $@

testdir testdir.enospc testdir.ext2:
	mkdir $@

root: .PHONY
	@if [ `id -u` -ne 0 ]; then echo Need root for check, try partcheck >&2; exit 1; fi

partcheck: $(PARTPROGS) testdir/rofile testdir/rwfile testdir/wofile
	./runtests.sh $(PARTPROGS)

ext2.img:
	dd if=/dev/zero bs=1M count=10 of=$@
	mke2fs -F -b 4096 $@

extracheck: $(EXTRAPROGS) root testdir.ext2 testdir.enospc ext2.img
	mount -o loop -t ext2 ext2-enospc.img testdir.enospc
	./runtests.sh cases/10.p; ret=$$?; umount testdir.enospc; exit $$ret
	mount -o loop -t ext2 ext2.img testdir.ext2
	./runtests.sh cases/8.p; ret=$$?; umount testdir.ext2; exit $$ret

check: partcheck extracheck

=== .pc/0022-Add-time64-public-functions-on-32-bit-architectures.patch/src/Makefile ===
prefix ?= /usr
includedir ?= $(prefix)/include
libdir ?= $(prefix)/lib

MK_CPPFLAGS = -I. $(CPPFLAGS)
CFLAGS ?= -Wall -g -fomit-frame-pointer -O2
MK_CFLAGS = -fPIC $(CFLAGS)
SO_CFLAGS = -shared $(MK_CFLAGS)
L_CFLAGS = $(MK_CFLAGS)
MK_LDFLAGS = $(LDFLAGS)
ENABLE_SHARED ?= 1

soname=libaio.so.1
minor=0
micro=2
libname=$(soname).$(minor).$(micro)
all_targets += libaio.a

ifeq ($(ENABLE_SHARED),1)
all_targets += $(libname)
endif

all: $(all_targets)

# libaio provided functions
libaio_srcs := io_queue_init.c io_queue_release.c
libaio_srcs += io_queue_wait.c io_queue_run.c

# real syscalls
libaio_srcs += aio_pgetevents.c aio_getevents.c
libaio_srcs += io_getevents.c io_submit.c io_cancel.c
libaio_srcs += io_setup.c io_destroy.c io_pgetevents.c

# old symbols
libaio_srcs += compat-0_1.c

libaio_objs := $(patsubst %.c,%.ol,$(libaio_srcs))
libaio_sobjs := $(patsubst %.c,%.os,$(libaio_srcs))

$(libaio_objs) $(libaio_sobjs): libaio.h

%.os: %.c
	$(CC) $(MK_CPPFLAGS) $(SO_CFLAGS) -c -o $@ $<

%.ol: %.c
	$(CC) $(MK_CPPFLAGS) $(L_CFLAGS) -c -o $@ $<

AR ?= ar
RANLIB ?= ranlib
libaio.a: $(libaio_objs)
	rm -f libaio.a
	$(AR) r libaio.a $^
	$(RANLIB) libaio.a

$(libname): $(libaio_sobjs) libaio.map
	$(CC) $(MK_CPPFLAGS) $(MK_CFLAGS) -c struct_offsets.c
	$(CC) $(SO_CFLAGS) -Wl,--version-script=libaio.map -Wl,-soname=$(soname) -o $@ $(libaio_sobjs) $(MK_LDFLAGS)

install: $(all_targets)
	install -D -m 644 libaio.h $(DESTDIR)$(includedir)/libaio.h
	install -D -m 644 libaio.a $(DESTDIR)$(libdir)/libaio.a
ifeq ($(ENABLE_SHARED),1)
	install -D -m 755 $(libname) $(DESTDIR)$(libdir)/$(libname)
	ln -sf $(libname) $(DESTDIR)$(libdir)/$(soname)
	ln -sf $(libname) $(DESTDIR)$(libdir)/libaio.so
endif

$(libaio_objs): libaio.h

clean:
	rm -f $(all_targets) $(libaio_objs) $(libaio_sobjs) $(soname).new
	rm -f *.so* *.a *.o

=== .pc/0025-build-Use-a-temporary-SONAME-bump-to-avoid-stomping-.patch/src/Makefile ===
prefix ?= /usr
includedir ?= $(prefix)/include
libdir ?= $(prefix)/lib

MK_CPPFLAGS = -I. -D_FILE_OFFSET_BITS=64 -D_TIME_BITS=64 $(CPPFLAGS)
CFLAGS ?= -Wall -g -fomit-frame-pointer -O2
MK_CFLAGS = -fPIC $(CFLAGS)
SO_CFLAGS = -shared $(MK_CFLAGS)
L_CFLAGS = $(MK_CFLAGS)
MK_LDFLAGS = $(LDFLAGS)
ENABLE_SHARED ?= 1

soname=libaio.so.1
minor=0
micro=2
libname=$(soname).$(minor).$(micro)
all_targets += libaio.a

ifeq ($(ENABLE_SHARED),1)
all_targets += $(libname)
endif

all: $(all_targets)

# libaio provided functions
libaio_srcs := io_queue_init.c io_queue_release.c
libaio_srcs += io_queue_wait.c io_queue_run.c

# real syscalls
libaio_srcs += aio_pgetevents.c aio_getevents.c
libaio_srcs += io_getevents.c io_submit.c io_cancel.c
libaio_srcs += io_setup.c io_destroy.c io_pgetevents.c
libaio_srcs += io_pgetevents_time64.c io_getevents_time64.c

# old symbols
libaio_srcs += compat-0_1.c

libaio_objs := $(patsubst %.c,%.ol,$(libaio_srcs))
libaio_sobjs := $(patsubst %.c,%.os,$(libaio_srcs))

$(libaio_objs) $(libaio_sobjs): libaio.h

%.os: %.c
	$(CC) $(MK_CPPFLAGS) $(SO_CFLAGS) -c -o $@ $<

%.ol: %.c
	$(CC) $(MK_CPPFLAGS) $(L_CFLAGS) -c -o $@ $<

AR ?= ar
RANLIB ?= ranlib
libaio.a: $(libaio_objs)
	rm -f libaio.a
	$(AR) r libaio.a $^
	$(RANLIB) libaio.a

$(libname): $(libaio_sobjs) libaio.map
	$(CC) $(MK_CPPFLAGS) $(MK_CFLAGS) -c struct_offsets.c
	$(CC) $(SO_CFLAGS) -Wl,--version-script=libaio.map -Wl,-soname=$(soname) -o $@ $(libaio_sobjs) $(MK_LDFLAGS)

install: $(all_targets)
	install -D -m 644 libaio.h $(DESTDIR)$(includedir)/libaio.h
	install -D -m 644 libaio.a $(DESTDIR)$(libdir)/libaio.a
ifeq ($(ENABLE_SHARED),1)
	install -D -m 755 $(libname) $(DESTDIR)$(libdir)/$(libname)
	ln -sf $(libname) $(DESTDIR)$(libdir)/$(soname)
	ln -sf $(libname) $(DESTDIR)$(libdir)/libaio.so
endif

$(libaio_objs): libaio.h

clean:
	rm -f $(all_targets) $(libaio_objs) $(libaio_sobjs) $(soname).new
	rm -f *.so* *.a *.o

=== .pc/0026-harness-Disable-failing-test-23.patch/harness/Makefile ===
# foo.
TEST_SRCS:=$(shell find cases/ -name \*.t | sort -n -t/ -k2)
EXTRAPROGS:=cases/8.p cases/10.p
PARTPROGS:=$(filter-out $(EXTRAPROGS), $(patsubst %.t,%.p,$(TEST_SRCS)))
PROGS:=$(PARTPROGS) $(EXTRAPROGS)
HARNESS_SRCS:=main.c
# io_queue.c

MK_CPPFLAGS = -I../src -D_FILE_OFFSET_BITS=64 -D_TIME_BITS=64 $(CPPFLAGS)
CFLAGS ?= -Wall -Werror -g -O2
MK_CFLAGS = $(CFLAGS)
#-lpthread -lrt
MK_LDFLAGS = main.c $(LIBAIO) -lpthread $(LDFLAGS)

# gcc-11 does not like the test case in 3.t that
# passes an invalid pointer (-1) to the kernel, so
# tell the compiler we do not need a warning here
cases/3.p:	MK_CFLAGS+=-Wno-stringop-overflow

# Change this on the build line to run tests against the installed libraries:
# make LIBAIO=-laio partcheck
LIBAIO?=../src/libaio.a

all: $(PROGS)

$(PROGS): %.p: %.t $(HARNESS_SRCS)
	$(CC) $(MK_CPPFLAGS) $(MK_CFLAGS) -DTEST_NAME=\"$<\" -o $@ $(MK_LDFLAGS)

clean:
	rm -f $(PROGS) *.o runtests.out tempfile testfile
	rm -f testdir/rofile testdir/wofile testdir/rwfile
	rmdir testdir || true

.PHONY:

testdir/rofile: testdir .PHONY
	rm -f $@
	echo "test" >$@
	chmod 400 $@

testdir/wofile: testdir .PHONY
	rm -f $@
	echo "test" >$@
	chmod 200 $@

testdir/rwfile: testdir .PHONY
	rm -f $@
	echo "test" >$@
	chmod 600 $@

testdir testdir.enospc testdir.ext2:
	mkdir $@

root: .PHONY
	@if [ `id -u` -ne 0 ]; then echo Need root for check, try partcheck >&2; exit 1; fi

partcheck: $(PARTPROGS) testdir/rofile testdir/rwfile testdir/wofile
	./runtests.sh $(PARTPROGS)

ext2.img:
	dd if=/dev/zero bs=1M count=10 of=$@
	mke2fs -F -b 4096 $@

extracheck: $(EXTRAPROGS) root testdir.ext2 testdir.enospc ext2.img
	mount -o loop -t ext2 ext2-enospc.img testdir.enospc
	./runtests.sh cases/10.p; ret=$$?; umount testdir.enospc; exit $$ret
	mount -o loop -t ext2 ext2.img testdir.ext2
	./runtests.sh cases/8.p; ret=$$?; umount testdir.ext2; exit $$ret

check: partcheck extracheck

=== debian/changelog ===
libaio (0.3.113-6build1.1trisquel1) ecne; urgency=medium

  * Fetch and build as udeb dependency for debian-installer.

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Mon, 27 Jan 2025 18:44:40 +0000

libaio (0.3.113-6build1.1) noble; urgency=medium

  * SRU: LP: #2083480: No-change rebuild to disable frame pointers on
    ppc64el and s390x.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 02 Oct 2024 14:40:51 +0200

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,5 @@
 Source: libaio
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
 XSBC-Original-Maintainer: Guillem Jover <guillem@debian.org>
 Priority: optional
 Section: libs
